SystemOrganization addCategory: #'OB-Metacello'!

!Class methodsFor: '*ob-metacello' stamp: 'DaleHenrichs 08/30/2010 15:17'!
isMetacelloConfig

	^false! !

!OBCodeBrowser methodsFor: '*ob-metacello' stamp: 'dkh 1/7/2011 13:35'!
cmdMetacello
	<command>

	^OBCmdMetacello allSubclasses! !

OBCommand subclass: #OBCmdMetacello
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Metacello'!

!OBCmdMetacello methodsFor: 'private' stamp: 'DaleHenrichs 11/8/2010 10:33'!
chooseVersion: selectBlock message: message
	^self chooseVersion: selectBlock message: message includeSymbolicVersions: true! !

!OBCmdMetacello methodsFor: 'private' stamp: 'DaleHenrichs 1/24/2011 17:07'!
chooseVersion: selectBlock message: message includeSymbolicVersions: includeSymbolicVersions
	| project symbolicVersions versions loadedVersion labels |
	project := self selectedProjectInstance.
	symbolicVersions := OrderedCollection new.
	includeSymbolicVersions
		ifTrue: [ 
			symbolicVersions := (project symbolicVersionSymbols select: [ :each | project hasVersion: each ])
				collect: [ :each | 
					{(each printString , ' -> ' , (project symbolicVersionMap at: each)).
					(project version: each)} ] ].
	versions := (self versions select: selectBlock) reverse asOrderedCollection.
	loadedVersion := self currentVersion.
	labels := (symbolicVersions collect: [ :ar | ar at: 1 ]) asOrderedCollection.
	labels := labels
		,
			(versions
				collect: [ :vrsn | 
					| blessing vrsnString |
					blessing := vrsn blessing == #release
						ifTrue: [ '' ]
						ifFalse: [ ' <' , vrsn blessing asString , '> ' ].
					vrsnString := vrsn versionString , blessing.
					vrsn = loadedVersion
						ifTrue: [ '* ' , vrsnString ]
						ifFalse: [ vrsnString ] ]).
	labels addLast: 'All versions'.
	versions := (symbolicVersions collect: [ :ar | ar at: 2 ]) asOrderedCollection , versions.
	versions addLast: #all.
	^ OBChoiceRequest
		prompt: message
		labels: labels
		values: versions
		lines:
			{(symbolicVersions size).
			(versions size - 1)}! !

!OBCmdMetacello methodsFor: 'private' stamp: 'DaleHenrichs 3/11/2010 17:35'!
commitPackageSpec: packageSpec into: repositoryList with: message
	| gofer |
	gofer := Gofer new.
	gofer disablePackageCache.
	repositoryList do: [:repository | gofer repository: repository].
	gofer package: packageSpec name.
	gofer commit: message
! !

!OBCmdMetacello methodsFor: 'private' stamp: 'dkh 11/3/2009 09:21'!
currentVersion

	^self selectedProjectInstance currentVersion! !

!OBCmdMetacello methodsFor: 'private' stamp: 'dkh 11/3/2009 09:21'!
currentVersionString

	| cv |
	^(cv := self currentVersion) == nil
		ifTrue: [ '' ]
		ifFalse: [ cv versionString ]! !

!OBCmdMetacello methodsFor: 'execution' stamp: 'DaleHenrichs 08/30/2010 15:38'!
executeLoadLatestPackages

	| version |
	(version := self promptForBaselineVersion: 'Which version would you like to load from?') ~~ nil
		ifTrue: [ 
			version load: version defaultPackageNamesToLoad.
			OBInformRequest message: version versionString, ' loaded.']! !

!OBCmdMetacello methodsFor: 'execution' stamp: 'DaleHenrichs 08/30/2010 15:38'!
executeLoadProject

	| version |
	(version := self promptForVersion: 'Which version would you like loaded?') ~~ nil
		ifTrue: [ 
			version load: version defaultPackageNamesToLoad.
			OBInformRequest message: version versionString, ' loaded.']! !

!OBCmdMetacello methodsFor: 'execution' stamp: 'DaleHenrichs 11/15/2010 18:33'!
executeSaveProject: message

	MetacelloToolBox saveConfigurationPackageFor: self selectedClass name asString description: message! !

!OBCmdMetacello methodsFor: 'execution' stamp: 'DaleHenrichs 11/18/2010 11:20'!
executeUpdatePackageMethods: version description: description
	(MetacelloToolBox
		updateDevelopment: version versionString
		for: self selectedClass name asString
		updateProjects: false
		description: description) notEmpty
		ifTrue: [ 
			(OBConfirmationRequest
				prompt: 'Package methods updated for ' , version versionString , '. Would you like to save the project?'
				confirm: 'Save project'
				cancel: 'Cancel') == true
				ifTrue: [ 
					| strm |
					strm := WriteStream on: String new.
					strm
						nextPutAll: version versionString , ':';
						cr;
						cr;
						nextPutAll: description.
					self executeSaveProject: strm contents ] ]
		ifFalse: [ OBInformRequest message: 'All methods for ' , version versionString , ' are up-to-date.' ]! !

!OBCmdMetacello methodsFor: 'testing' stamp: 'DaleHenrichs 08/30/2010 15:16'!
isActive
	^ ((target isKindOf: OBClassNode)
		and: [ requestor isSelected: target ])
			and: [ [ self selectedClass isMetacelloConfig ] on: Error do: [:ex | ex return: false] ]
! !

!OBCmdMetacello methodsFor: 'private' stamp: 'dkh 10/27/2009 11:43'!
promptForBaselineVersion: message

	| versions labels |
	versions := self reversedVersions select: [:vrsn | vrsn blessing == #baseline ].
	labels := versions collect: [:vrsn |vrsn versionString ].
	^OBChoiceRequest prompt: message labels: labels values: versions
! !

!OBCmdMetacello methodsFor: 'private' stamp: 'DaleHenrichs 11/18/2010 10:36'!
promptForDevelopmentVersion: message
	| versions labels project |
	versions := (self reversedVersions select: [ :vrsn | vrsn blessing == #development ]) asOrderedCollection.
	labels := (versions collect: [ :vrsn | vrsn versionString ]) asOrderedCollection.
	(project := self selectedProjectInstance) symbolicVersionSymbols
		do: [ :each | 
			each == #development
				ifTrue: [ 
					versions addFirst: (project version: each).
					labels addFirst: each printString , ' -> ' , (project symbolicVersionMap at: each) ] ].
	versions isEmpty
		ifTrue: [ 
			self inform: 'No development versions available'.
			^ nil ].
	^ OBChoiceRequest prompt: message labels: labels values: versions! !

!OBCmdMetacello methodsFor: 'private' stamp: 'DaleHenrichs 08/30/2010 15:36'!
promptForVersion: message

	| loadedVersion version |
	loadedVersion := self currentVersion.
	version := self 
		chooseVersion: [:vrsn |
			"show current version and all versions later than current version"
			loadedVersion == nil
				or: [ vrsn >= loadedVersion ]] 
		message: message.
	version == #all 
		ifTrue: [ version := self chooseVersion: [:vrsn | true ] message: message ].
	^version
! !

!OBCmdMetacello methodsFor: 'private' stamp: 'dkh 11/3/2009 09:20'!
reversedVersions

	^self versions reverse! !

!OBCmdMetacello methodsFor: 'private' stamp: 'dkh 7/24/2009 17:49'!
selectedClass

	^target theNonMetaClass! !

!OBCmdMetacello methodsFor: 'private' stamp: 'dkh 9/10/2009 15:00'!
selectedProjectInstance

	^self selectedClass new project! !

!OBCmdMetacello methodsFor: 'private' stamp: 'dkh 11/3/2009 09:20'!
versions

	^self selectedProjectInstance versions! !

OBCmdMetacello subclass: #OBCmdMetacelloCurrentConfigurationVersion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Metacello'!

!OBCmdMetacelloCurrentConfigurationVersion methodsFor: 'execution' stamp: 'dkh 9/14/2009 10:23'!
execute

	| version |
	(version := self selectedProjectInstance currentVersion) ~~ nil
		ifTrue: [ OBInformRequest message: version printString ] 
		ifFalse: [ OBInformRequest message: 'The current version for ', self selectedProjectInstance label, ' is unknown.']! !

!OBCmdMetacelloCurrentConfigurationVersion methodsFor: 'accessing' stamp: 'DaleHenrichs 11/8/2010 10:20'!
group
	^ #metacelloConfiguration! !

!OBCmdMetacelloCurrentConfigurationVersion methodsFor: 'accessing' stamp: 'DaleHenrichs 11/8/2010 10:17'!
label

	^'Configuration Version'! !

OBCmdMetacello subclass: #OBCmdMetacelloLoadConfigurationVersion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Metacello'!

!OBCmdMetacelloLoadConfigurationVersion methodsFor: 'execution' stamp: 'dkh 10/23/2009 12:00'!
execute

	MetacelloPlatform current transact: [ self executeLoadProject ]! !

!OBCmdMetacelloLoadConfigurationVersion methodsFor: 'accessing' stamp: 'DaleHenrichs 11/8/2010 10:20'!
group
	^ #metacelloConfiguration! !

!OBCmdMetacelloLoadConfigurationVersion methodsFor: 'accessing' stamp: 'DaleHenrichs 12/3/2010 13:56'!
label

	^'Load Version'! !

OBCmdMetacello subclass: #OBCmdMetacelloNestedSavePackages
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Metacello'!

!OBCmdMetacelloNestedSavePackages methodsFor: 'private' stamp: 'DaleHenrichs 3/17/2010 13:05'!
commitConfigurationFor: loaderDirective message: initialMessage
	"Commit the config if it has been modified"

	| projectPackage message |
	loaderDirective spec == nil ifTrue: [ ^nil ].
	projectPackage := loaderDirective spec project projectPackage.
	(self packageNeedsSaving: projectPackage) ifFalse: [ ^nil ].
	(OBConfirmationRequest 
		prompt: 'The configuration for ', loaderDirective label printString, ' has been modified. Would you like to commit the configuration package?' 
		confirm: 'Commit configuration' 
		cancel: 'Skip') == true
			ifTrue: [
				message := loaderDirective spec versionString, ':', String cr, String cr, initialMessage.
				message := OBMultiLineTextRequest 
					prompt: 'Enter commit message for configuration: ', loaderDirective label printString
					template: message.
				message == nil ifTrue: [ ^nil ].
				projectPackage goferCommitPackage: message ].
	^message! !

!OBCmdMetacelloNestedSavePackages methodsFor: 'private' stamp: 'DaleHenrichs 03/12/2010 15:02'!
commitDirective: directive message: message

	| repo repos |
	(repo := directive repository) == nil 
		ifTrue: [ repos := directive loader repositoryMap at: directive externalReference packageName ]
		ifFalse: [ repos := Array with: repo ].
	self commitPackageSpec: directive spec into: repos with: message! !

!OBCmdMetacelloNestedSavePackages methodsFor: 'private' stamp: 'DaleHenrichs 3/15/2010 11:20'!
commitPackages: packages in: loaderDirective message: initialMessage

	| packageNames message projectPackage |
	packageNames := ''.
	packages do: [:directive | packageNames := packageNames, '  - ', directive spec label, String cr ].
	packageNames notEmpty
		ifTrue: [ 
			(OBConfirmationRequest 
				prompt: 'Packages in ', loaderDirective label, ' have been modified. Would you like to commit the packages?' 
				confirm: 'Commit packages' 
				cancel: 'Skip') ~~ true
					ifTrue: [ ^initialMessage ].
			message := initialMessage, String cr, packageNames.
			message := OBMultiLineTextRequest 
				prompt: 'Enter commit message for packages in: ', loaderDirective label printString
				template: message.
			message == nil ifTrue: [ ^nil ].
			MetacelloPlatform current
				collection: packages 
				do: [:directive | 
					self commitDirective: directive message: message ]
				displaying: 'Committing packages in ', loaderDirective label.	
			(OBConfirmationRequest 
				prompt: 'Packages in ', loaderDirective label printString, ' saved. Would you like to update the configuration?' 
				confirm: 'Update configuration' 
				cancel: 'Skip') == true
					ifTrue: [ self executeUpdatePackageMethods: loaderDirective message: message ].
			^message ].
	^self commitConfigurationFor: loaderDirective message: initialMessage! !

!OBCmdMetacelloNestedSavePackages methodsFor: 'private' stamp: 'DaleHenrichs 3/11/2010 18:11'!
commitPackageSpec: packageSpec into: repositoryList with: message

	repositoryList size > 1 
		ifTrue: [
			(OBConfirmationRequest 
				prompt: 'The package: ', packageSpec name, ' will be committed to more than one repository. Is that all right?'
				confirm: 'Commit to mulitple repository' 
				cancel: 'Skip') ~~ true ifTrue: [ ^self ]].
	super commitPackageSpec: packageSpec into: repositoryList with: message! !

!OBCmdMetacelloNestedSavePackages methodsFor: 'private' stamp: 'DaleHenrichs 3/17/2010 13:00'!
configsNeedSaving: version

	| map |
	map := IdentityDictionary new.
	(version record: 'ALL') loadDirective versionDirectivesDo: [:loaderDirective | | coll |
		loaderDirective spec notNil
			ifTrue: [ 
				(self packageNeedsSaving: loaderDirective spec project projectPackage)
					ifTrue: [ map at: loaderDirective put: #() ]]].
	^map! !

!OBCmdMetacelloNestedSavePackages methodsFor: 'execution' stamp: 'DaleHenrichs 3/17/2010 13:13'!
execute

	| map |
	MetacelloPlatform current transact: [ | version |
		(version := self promptForVersion: 'Saving packages for which version?') ~~ nil
			ifTrue: [
				MetacelloPlatform current 
					do: [ map := self packagesNeedSaving: version ] 
					displaying: 'Analyzing packages ', version versionNumber printString, ' of ', version spec label.
				map notEmpty
					ifTrue: [ | message skipped |
						message := '- commit message for:'.
						skipped := IdentitySet new.
						map associations do: [:assoc |  | newMessage directive configClass |
							directive := assoc key.
							configClass := directive spec project configuration class.
							(skipped includes: configClass)
								ifFalse: [ 
									(newMessage := self commitPackages: assoc value in: directive message: message) == nil
										ifTrue: [ skipped add:  configClass ]
										ifFalse: [ message := newMessage ]]].
						self saveConfigsFor: version message: message.
						^OBInformRequest message: 'Done.'].
				(self saveConfigsFor: version message: '- commit message for:') == nil 
					ifTrue: [ OBInformRequest message: 'No packages for ', version versionString, ' saved.' ]
					ifFalse: [ OBInformRequest message: 'Done.' ]]]! !

!OBCmdMetacelloNestedSavePackages methodsFor: 'private' stamp: 'DaleHenrichs 11/18/2010 16:49'!
executeUpdatePackageMethods: loaderDirective message: initialMessage

	| versionSpec config versionString |
	versionSpec := loaderDirective spec.
	config := versionSpec project configuration.
	versionString := versionSpec versionString.
	(MetacelloVersionConstructor 
		updatePackageMethodIn: config class new
		sourceVersion: versionString)
		ifTrue: [ 
			(OBConfirmationRequest prompt: 'Package methods updated for ', loaderDirective label, '. Would you like to save the updated configuration?' confirm: 'Save configuration' cancel: 'Cancel') == true
				ifTrue: [ | message projectPackage repositoryList |
					message := loaderDirective spec versionString, ':', String cr, String cr, initialMessage.
					message := OBMultiLineTextRequest 
						prompt: 'Enter commit message for configuration: ', loaderDirective label printString
						template: message.
					message == nil ifTrue: [ ^initialMessage ].
					projectPackage := config project projectPackage.
					repositoryList := loaderDirective loader repositoriesFrom: projectPackage repositorySpecs ignoreOverrides: true.
					self commitPackageSpec: projectPackage into: repositoryList with: message].
			^self].
	self commitConfigurationFor: loaderDirective message: initialMessage! !

!OBCmdMetacelloNestedSavePackages methodsFor: 'accessing' stamp: 'dkh 6/29/2009 10:09'!
group
	^ #metacelloPackages! !

!OBCmdMetacelloNestedSavePackages methodsFor: 'testing' stamp: 'DaleHenrichs 11/20/2010 07:55'!
isActive
	self flag: 'need to rewrite using toolbox'.
	^ false! !

!OBCmdMetacelloNestedSavePackages methodsFor: 'accessing' stamp: 'DaleHenrichs 3/11/2010 17:56'!
label

	^'Save Packages (nested)'! !

!OBCmdMetacelloNestedSavePackages methodsFor: 'user interface' stamp: 'DaleHenrichs 5/12/2010 16:32'!
order

	^'1'! !

!OBCmdMetacelloNestedSavePackages methodsFor: 'private' stamp: 'DaleHenrichs 03/12/2010 13:50'!
packageNeedsSaving: packageSpec

	| wc |
	^((wc := packageSpec workingCopy) ~~ nil) 
		and: [wc ancestry ancestors isEmpty 
				or: [ wc modified ]]! !

!OBCmdMetacelloNestedSavePackages methodsFor: 'private' stamp: 'DaleHenrichs 3/17/2010 12:56'!
packagesNeedSaving: version

	| map |
	map := IdentityDictionary new.
	(version record: 'ALL') loadDirective versionDirectivesDo: [:loaderDirective | | coll |
		coll := OrderedCollection new.
		loaderDirective packagesDo: [:packageDirective |
			(self packageNeedsSaving: packageDirective spec)
				ifTrue: [ coll add: packageDirective ]].
		coll notEmpty 
			ifTrue: [ "dirty packages in configuration"
				map at: loaderDirective put: coll ]].
	^map! !

!OBCmdMetacelloNestedSavePackages methodsFor: 'execution' stamp: 'DaleHenrichs 3/17/2010 13:15'!
saveConfigsFor: version message: initialMessage

	| map message |
	MetacelloPlatform current 
		do: [ map := self configsNeedSaving: version ] 
		displaying: 'Analyzing configs ', version versionNumber printString, ' of ', version spec label.
	map isEmpty ifTrue: [ ^nil ].
	message := initialMessage.
	map associations do: [:assoc | message := self commitConfigurationFor: assoc key message: message ]! !

OBCmdMetacello subclass: #OBCmdMetacelloSaveConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Metacello'!

!OBCmdMetacelloSaveConfiguration methodsFor: 'execution' stamp: 'DaleHenrichs 11/15/2010 18:37'!
execute
	| message |
	message := OBMultiLineTextRequest prompt: 'Enter commit message.'.
	message == nil
		ifTrue: [ ^ OBInformRequest message: 'Commit aborted.' ].
	MetacelloPlatform current transact: [ self executeSaveProject: message ]! !

!OBCmdMetacelloSaveConfiguration methodsFor: 'accessing' stamp: 'DaleHenrichs 11/8/2010 10:20'!
group
	^ #metacelloConfiguration! !

!OBCmdMetacelloSaveConfiguration methodsFor: 'accessing' stamp: 'DaleHenrichs 11/8/2010 10:17'!
label

	^'Save Configuration'! !

!OBCmdMetacelloSaveConfiguration methodsFor: 'user interface' stamp: 'DaleHenrichs 5/12/2010 16:33'!
order

	^'3'! !

OBCmdMetacello subclass: #OBCmdMetacelloSavePackages
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Metacello'!

!OBCmdMetacelloSavePackages methodsFor: 'execution' stamp: 'DaleHenrichs 11/18/2010 10:30'!
execute
	MetacelloPlatform current
		transact: [ 
			| version |
			(version := self promptForDevelopmentVersion: 'Saving packages for which version?') ~~ nil
				ifTrue: [ 
					| message saved |
					message := OBMultiLineTextRequest prompt: 'Enter commit message.'.
					message == nil
						ifTrue: [ ^ OBInformRequest message: 'Commit aborted.' ].
					saved := (MetacelloToolBox
						saveModifiedDevelopmentPackages: version versionString
						for: self selectedClass name asString
						description: message) notEmpty
						ifTrue: [ 
							(OBConfirmationRequest
								prompt: 'Packages for ' , version versionString , ' saved. Would you like to update the package methods?'
								confirm: 'Update package methods'
								cancel: 'Cancel') == true
								ifTrue: [self executeUpdatePackageMethods: version description: message ] ]
						ifFalse: [ OBInformRequest message: 'No packages for ' , version versionString , ' saved.' ] ] ]! !

!OBCmdMetacelloSavePackages methodsFor: 'accessing' stamp: 'DaleHenrichs 3/11/2010 13:03'!
group
	^ #metacelloPackages! !

!OBCmdMetacelloSavePackages methodsFor: 'accessing' stamp: 'DaleHenrichs 3/11/2010 17:56'!
label

	^'Save Packages'! !

!OBCmdMetacelloSavePackages methodsFor: 'user interface' stamp: 'DaleHenrichs 5/12/2010 16:32'!
order

	^'1'! !

OBCmdMetacello subclass: #OBCmdMetacelloSpawnPackageMethods
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Metacello'!

!OBCmdMetacelloSpawnPackageMethods methodsFor: 'execution' stamp: 'DaleHenrichs 11/24/2010 08:40'!
execute
	MetacelloPlatform current
		transact: [ 
			| sourceVersion selector targetVersionString vn |
			(sourceVersion := self chooseVersion: [ :vrsn | true ] message: 'Select the version to be used as the source?')
				~~ nil
				ifTrue: [ 
					vn := sourceVersion versionString asMetacelloVersionNumber copy incrementMinorVersionNumber.
					targetVersionString := OBTextRequest
						prompt: 'Enter the target version number (source: ' , sourceVersion versionString , ').'
						template: vn printString.
					MetacelloToolBox
						createVersion: targetVersionString
						for: self selectedClass name asString
						from: sourceVersion versionString
						description: '' ] ]! !

!OBCmdMetacelloSpawnPackageMethods methodsFor: 'accessing' stamp: 'dkh 10/7/2009 14:09'!
group
	^ #metacelloPackages! !

!OBCmdMetacelloSpawnPackageMethods methodsFor: 'accessing' stamp: 'DaleHenrichs 11/15/2010 19:20'!
label

	^'Create New Version'! !

!OBCmdMetacelloSpawnPackageMethods methodsFor: 'user interface' stamp: 'DaleHenrichs 5/12/2010 16:33'!
order

	^'2'! !

OBCmdMetacello subclass: #OBCmdMetacelloUpdateConfigurationPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Metacello'!

!OBCmdMetacelloUpdateConfigurationPackage methodsFor: 'execution' stamp: 'dkh 10/23/2009 12:04'!
execute
	
	MetacelloPlatform current transact: [ | message |
		message := self selectedProjectInstance updateProject
			ifTrue: [ self selectedProjectInstance label, ' project updated. Would you like to load a version of the project?' ]
			ifFalse: [self selectedProjectInstance label, ' already up-to-date. Would you like to load a version of the project?' ].
		(OBConfirmationRequest prompt: message confirm: 'Load project version' cancel: 'Cancel') == true
			ifTrue: [ self executeLoadProject ]]! !

!OBCmdMetacelloUpdateConfigurationPackage methodsFor: 'accessing' stamp: 'DaleHenrichs 11/8/2010 10:20'!
group
	^ #metacelloConfiguration! !

!OBCmdMetacelloUpdateConfigurationPackage methodsFor: 'accessing' stamp: 'DaleHenrichs 11/8/2010 10:18'!
label

	^'Update Configuration Package'! !

OBCmdMetacello subclass: #OBCmdMetacelloUpdatePackageMethods
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Metacello'!

!OBCmdMetacelloUpdatePackageMethods methodsFor: 'execution' stamp: 'DaleHenrichs 11/28/2010 10:51'!
execute
	MetacelloPlatform current
		transact: [ 
			| version |
			(version := self promptForDevelopmentVersion: 'Updating methods for which version?') ~~ nil
				ifTrue: [ 
					| description |
					(description := OBMultiLineTextRequest prompt: 'Enter description of chanages.') == nil
						ifTrue: [ description := '' ].
					self executeUpdatePackageMethods: version description: description ] ]! !

!OBCmdMetacelloUpdatePackageMethods methodsFor: 'accessing' stamp: 'dkh 6/29/2009 10:06'!
group
	^ #metacelloPackages! !

!OBCmdMetacelloUpdatePackageMethods methodsFor: 'accessing' stamp: 'dkh 7/8/2009 16:42'!
label

	^'Update Package Methods'! !

!OBCmdMetacelloUpdatePackageMethods methodsFor: 'user interface' stamp: 'DaleHenrichs 5/12/2010 16:33'!
order

	^'2'! !

OBCmdMetacello subclass: #OBCmdMetacelloValidateConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Metacello'!

OBCmdMetacelloValidateConfiguration subclass: #OBCmdMetacelloDebugValidateConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Metacello'!

!OBCmdMetacelloDebugValidateConfiguration methodsFor: 'accessing' stamp: 'DaleHenrichs 11/24/2010 09:07'!
debugList

	^#(error criticalWarning)! !

!OBCmdMetacelloDebugValidateConfiguration methodsFor: 'accessing' stamp: 'DaleHenrichs 11/24/2010 09:06'!
label

	^'Debug Validate Configuration'! !

!OBCmdMetacelloValidateConfiguration methodsFor: 'accessing' stamp: 'DaleHenrichs 11/24/2010 09:06'!
debugList

	^#()! !

!OBCmdMetacelloValidateConfiguration methodsFor: 'execution' stamp: 'DaleHenrichs 11/24/2010 09:05'!
execute
	| issues |
	issues := MetacelloToolBox validateConfiguration: self selectedClass debug: self debugList recurse: true.
	issues isEmpty
		ifTrue: [ ^OBInformRequest message: 'No issues' ].
	issues := issues select: [ :issue | issue isCritical ].
	issues isEmpty
		ifTrue: [ OBInformRequest message: 'No critical issues' ]
		ifFalse: [ issues inspect ]! !

!OBCmdMetacelloValidateConfiguration methodsFor: 'accessing' stamp: 'DaleHenrichs 11/8/2010 10:20'!
group
	^ #metacelloValidation! !

!OBCmdMetacelloValidateConfiguration methodsFor: 'accessing' stamp: 'DaleHenrichs 11/8/2010 10:21'!
label

	^'Validate Configuration'! !

OBCmdMetacello subclass: #OBCmdMetacelloValidateConfigurationVersion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Metacello'!

!OBCmdMetacelloValidateConfigurationVersion methodsFor: 'execution' stamp: 'DaleHenrichs 11/24/2010 09:04'!
execute
	| issues version |
	version := self chooseVersion: [ :vrsn | true ] message: 'Select version to validate' includeSymbolicVersions: false.
	issues := MetacelloToolBox
		validateProject: self selectedProjectInstance
		version: version versionString
		debug: #()
		recurse: true.
	issues isEmpty
		ifTrue: [ ^OBInformRequest message: 'No issues' ].
	true
		ifTrue: [ issues := issues select: [ :issue | issue isCritical ] ].
	issues isEmpty
		ifTrue: [ OBInformRequest message: 'No critical issues' ]
		ifFalse: [ issues inspect ]! !

!OBCmdMetacelloValidateConfigurationVersion methodsFor: 'accessing' stamp: 'DaleHenrichs 11/8/2010 10:28'!
group
	^ #metacelloValidation! !

!OBCmdMetacelloValidateConfigurationVersion methodsFor: 'accessing' stamp: 'DaleHenrichs 11/8/2010 10:28'!
label

	^'Validate Configuration Version'! !
